package org.ow2.dsrg.fm.badger.simulation;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 26.7.2010
 * Time: 15:36:55
 * To change this template use File | Settings | File Templates.
 */
public class TBPNoActivityException extends TBPPropertyViolationException{

    boolean allThreadsInFinalState;

    public void setExpectedEventName(String expectedEventName) {
        this.expectedEventName = expectedEventName;
    }

    String expectedEventName;

    public TBPNoActivityException(boolean allThreadsInFinalState) {
        super("No activity error detected.");
        this.allThreadsInFinalState = allThreadsInFinalState;
    }



    @Override
    String errorDetails() {

        StringBuilder ret =new StringBuilder();

        if (!allThreadsInFinalState) {
            ret.append("Threads are deadlocked. ");
        }

        if (expectedEventName!=null) {
            ret.append("Expected event is ");
            ret.append(expectedEventName);
        }

        return ret.toString();
    }
}
