package org.ow2.dsrg.fm.tbplib.ltsa;

import org.ow2.dsrg.fm.tbplib.ltsa.visitor.LTSVisitor;
import org.ow2.dsrg.fm.tbplib.node.TBPThreadContainerNode;

/**
 * LTS transition labeled with thread. 
 * @author David Hauzar
 *
 */
public class LTSThread<REFERENCE> extends LTSImpl<TBPThreadContainerNode<REFERENCE>, REFERENCE> {
	/** Instances of this class are created via class LTSImpl.*/
	LTSThread(TBPThreadContainerNode<REFERENCE> tbpThread) {
		super(tbpThread, null);
	}
	
	public <RESULT> RESULT visit(LTSVisitor<RESULT, REFERENCE> visitor) {
		return visitor.visitThread(this);
	}
}