package org.ow2.dsrg.fm.tbplib.node.guard;

import org.ow2.dsrg.fm.tbplib.node.visitor.ConditionVisitor;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 9:39:54
 * To change this template use File | Settings | File Templates.
 */
public class TBPEquals<REFERENCE> extends TBPBinaryScalarCondition<REFERENCE> {

    public TBPEquals(REFERENCE left, REFERENCE right) {
        super(left, right);
    }


    
    @Override
    public <RESULT> RESULT visit(ConditionVisitor<RESULT, REFERENCE> resultreferencetbpVisitor) {
        return resultreferencetbpVisitor.visitTBPEquals(this);
    }

    @Override
    public ITBPCondition<REFERENCE> createNegation() {
        return new TBPNotEquals<REFERENCE>(left,right);
    }

    public boolean equals(Object obj) {
        if (obj instanceof TBPEquals) {
            return  super.equals(obj);
        }
        return false;
    }

}
