package org.ow2.dsrg.fm.tbplib.node.guard;

import org.ow2.dsrg.fm.tbplib.node.visitor.ConditionVisitor;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 10:44:02
 * To change this template use File | Settings | File Templates.
 */
public class TBPNondetCondition<REFERENCE> implements ITBPCondition<REFERENCE>{

    public <RESULT> RESULT visit(ConditionVisitor<RESULT, REFERENCE> resultreferencetbpVisitor) {
        return resultreferencetbpVisitor.visitTBPNondetCondition(this);
    }

    
        @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPNondetCondition) {
            return true;
        }
        return false;
    }


    protected static int prime = 7823;

    @Override
    public final int hashCode() {
        return prime+1;
    }

    @Override
    public ITBPCondition<REFERENCE> createNegation() {
        return this;
    }

    @Override
    public TBPNondetCondition<REFERENCE> clone() {
        try {
            return (TBPNondetCondition<REFERENCE>)super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
        }
        return null;
    }
}
