package org.ow2.dsrg.fm.tbplib.node.guard;

import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 2.8.2010
 * Time: 11:17:05
 * To change this template use File | Settings | File Templates.
 */
public abstract class TBPSetCondition<REFERENCE> extends TBPElementaryCondition<REFERENCE> {
    protected Set<REFERENCE> inSet;

    public TBPSetCondition(REFERENCE left, Set<REFERENCE> inSet) {
        super(left);
        this.inSet = inSet;
    }

    public Set<REFERENCE> getSet() {
        return inSet;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPSetCondition) {
            TBPSetCondition cond = (TBPSetCondition) obj;
            return  super.equals(obj) &&
                    ((inSet == null && cond.inSet == null) || inSet.equals(cond.inSet));
        }
        return false;
    }

    protected int recomputeHashCode() {

        int result = super.recomputeHashCode();
        result += inSet == null ? 0 : inSet.hashCode();
        result *= prime;

        return precomputedHashCode = result;
    }


}
