package org.ow2.dsrg.fm.tbplib.node.visitor;

import org.ow2.dsrg.fm.tbplib.node.guard.*;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 11:08:20
 * To change this template use File | Settings | File Templates.
 */
public interface ConditionVisitor<RESULT, REFERENCE> {
    RESULT visitTBPInSet(TBPInSet<REFERENCE> node);
    RESULT visitTBPNotInSet(TBPNotInSet<REFERENCE> node);
    RESULT visitTBPEquals(TBPEquals<REFERENCE> node);
    RESULT visitTBPNotEquals(TBPNotEquals<REFERENCE> node);
    RESULT visitTBPNondetCondition(TBPNondetCondition<REFERENCE> node);
    RESULT visitTBPNot(TBPNot<REFERENCE> node);
    RESULT visitTBPAnd(TBPAnd<REFERENCE> node);
    RESULT visitTBPOr(TBPOr<REFERENCE> node);    
}
