package org.ow2.dsrg.fm.tbplib.impl;

import java.util.Collections;
import java.util.List;

import org.ow2.dsrg.fm.tbplib.LeafNode;
import org.ow2.dsrg.fm.tbplib.node.TBPNode;

public abstract class TBPLeafNodeImpl<REFERENCE> extends TBPBoundedNodeImpl<REFERENCE> implements LeafNode {

	@Override
	public TBPNode<REFERENCE> getChild(int index) {
		throw new IndexOutOfBoundsException();
	}

	@Override
	public int getChildCount() {
		return 0;
	}

	@Override
	public List<TBPNode<REFERENCE>> getChildren() {
		return Collections.emptyList();
	}

	@Override
	public void setChild(int index, TBPNode<REFERENCE> childNode) {
		throw new IndexOutOfBoundsException();
	}


}
