/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.ltsa;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.ow2.dsrg.fm.tbplib.node.TBPReturn;

/**
 * Contains static methods that work on LTSAAutomatons.
 * 
 * @author caitt3am
 */
/* FIXME: Fix or remove this code !!!
public class Utils {

	public static List<Edge> findEmits(State s){
		final List<Edge> result = new ArrayList<Edge>();
		Utils.processGraph(s, new EdgeVisitor(){
			
			@Override
			public void visitEdge(Edge e) {
				if (e.getData() instanceof TBPResolvedEmit) {
					result.add(e);
				}
			}
			
		});
		return result;
	}
	
	public static List<Edge> findReturns(State s){
		final List<Edge> result = new ArrayList<Edge>();
		Utils.processGraph(s, new EdgeVisitor(){
			
			@Override
			public void visitEdge(Edge e) {
				if (e.getData() instanceof TBPReturn) {
					result.add(e);
				}
			}
			
		});
		return result;
	} 

	/**
	 * Visits all edges of graph reachable from s.
	 * @param s - Where to start
	 * @param v - this object is passed every visited edge 
	 */
/*
	public static void processGraph(State s, EdgeVisitor v){
		
		List<State> node_list = new ArrayList<State>();
		s.Mark();
		node_list.add(s);
		
		for(int index = 0; index < node_list.size(); index++){
			s = node_list.get(index);
			for(Edge e : s.getEdges()){
				assert e.getSource() == s : "Inconsistent edge";
				v.visitEdge(e);
				if(!e.getTarget().isMarked()){
					e.getTarget().Mark();
					node_list.add(e.getTarget());
				}
			}
		}
		
		for (State state : node_list) {
			state.Unmark();
		}
	}
	
	public static State copyGraph(State s){
		final Map<State,State> map = new HashMap<State, State>();
		processGraph(s, new EdgeVisitor(){

			@Override
			public void visitEdge(Edge e) {
				
				State old_target = e.getTarget();
				State old_source = e.getSource();
				
				State new_target = map.get(old_target);
				State new_source = map.get(old_source);
				
				if(new_target == null){
					new_target = new State();
					map.put(old_target, new_target);
				}
				
				if(new_source == null){
					new_source = new State();
					map.put(old_source, new_source);
				}
				
				new_source.addEdge(e.getData(), new_target);
			}
			
		});
		
		return map.get(s);
	} 

	private interface ReturnProcessor {
		void processReturn(Edge e, Binding const_binding);
	}

}
 */