package org.ow2.dsrg.fm.tbplib.node.guard;

import org.ow2.dsrg.fm.tbplib.node.visitor.ConditionVisitor;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 9:39:54
 * To change this template use File | Settings | File Templates.
 */
public class TBPNotEquals<REFERENCE> extends TBPBinaryScalarCondition<REFERENCE> {

    public TBPNotEquals(REFERENCE left, REFERENCE right) {
        super(left,right);
    }

    
    public <RESULT> RESULT visit(ConditionVisitor<RESULT, REFERENCE> resultreferencetbpVisitor) {
        return resultreferencetbpVisitor.visitTBPNotEquals(this);
    }

    @Override
    public ITBPCondition<REFERENCE> createNegation() {
        return new TBPEquals<REFERENCE>(left,right);
    }


    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPNotEquals) {
            return  super.equals(obj);        
        }
        return false;
    }

}