package org.ow2.dsrg.fm.tbplib.node.guard;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 11:37:54
 * To change this template use File | Settings | File Templates.
 */
public abstract class TBPUnaryCondition<REFERENCE> extends TBPConditionImpl<REFERENCE> {

    protected ITBPCondition<REFERENCE> child;

    protected TBPUnaryCondition(ITBPCondition<REFERENCE> operand) {
        this.child = operand;
    }

    public ITBPCondition<REFERENCE> getOperand() {
        return child;
    }



    public TBPUnaryCondition<REFERENCE> clone() {
        TBPUnaryCondition<REFERENCE> ret = (TBPUnaryCondition<REFERENCE>) super.clone();
        ret.child = child.clone();
        return ret;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPUnaryCondition) {
            TBPUnaryCondition cond = (TBPUnaryCondition) obj;
            return ((child == null && cond.child == null) || child.equals(cond.child)); 
        }
        return false;
    }


    protected int recomputeHashCode() {
        return (precomputedHashCode = child.hashCode()*prime); 
    }
}
