// $ANTLR 3.1.3 Mar 18, 2009 10:09:25 src\\grammars\\TBPTree.g 2011-05-06 10:54:56
 
	package org.ow2.dsrg.fm.tbplib.parser;
	
	import org.ow2.dsrg.fm.tbplib.node.*;
	import org.ow2.dsrg.fm.tbplib.node.guard.*;
	import org.ow2.dsrg.fm.tbplib.reference.*;
	import org.ow2.dsrg.fm.tbplib.architecture.*;
	import org.ow2.dsrg.fm.tbplib.util.*;
	import org.ow2.dsrg.fm.tbplib.Annotation;
	import org.ow2.dsrg.fm.tbplib.TBPProvisionMethodsNameChecker;
	import org.ow2.dsrg.fm.tbplib.TBPMethodNamePattern;
	import java.util.Map;
	import java.util.HashMap;
	import java.util.LinkedHashMap;
	import java.util.HashSet;
	import java.util.Set;
	import java.util.List;
	import java.util.ArrayList;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class TBPTree extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "TYPEDEF", "VARDEF", "PROVISION", "REACTION", "THREAD", "ANNOTATION", "ANN_PROVISION", "ANN_STATEMENT", "EVENT", "BLOCK", "METHOD_LIST", "METHOD_LIST_ELEMENT", "METHOD_CALL", "METHOD_DECL", "PARLIST", "PARLIST_DECL", "VALUE", "ASSIGNMENT", "RETURN", "SWITCH_ND", "DIGITS", "IDF", "WS", "COMMENT", "'component'", "'{'", "'types'", "';'", "'}'", "'vars'", "'provisions'", "'reactions'", "'threads'", "'='", "','", "'Mutex'", "'for'", "'@'", "'('", "')'", "'*'", "'.'", "'+'", "'|'", "'||'", "'|*'", "':'", "'NULL'", "'switch'", "'default'", "'?'", "'case'", "'while'", "'if'", "'else'", "'sync'", "'wait'", "'return'", "'&&'", "'=='", "'!='", "'!'"
    };
    public static final int T__29=29;
    public static final int T__64=64;
    public static final int T__28=28;
    public static final int T__65=65;
    public static final int T__62=62;
    public static final int IDF=25;
    public static final int T__63=63;
    public static final int ANNOTATION=9;
    public static final int DIGITS=24;
    public static final int METHOD_DECL=17;
    public static final int T__61=61;
    public static final int T__60=60;
    public static final int EOF=-1;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__57=57;
    public static final int T__58=58;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__59=59;
    public static final int RETURN=22;
    public static final int COMMENT=27;
    public static final int VARDEF=5;
    public static final int SWITCH_ND=23;
    public static final int T__50=50;
    public static final int T__42=42;
    public static final int ANN_PROVISION=10;
    public static final int T__43=43;
    public static final int THREAD=8;
    public static final int T__40=40;
    public static final int PROVISION=6;
    public static final int T__41=41;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int METHOD_LIST_ELEMENT=15;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int TYPEDEF=4;
    public static final int ANN_STATEMENT=11;
    public static final int VALUE=20;
    public static final int EVENT=12;
    public static final int METHOD_CALL=16;
    public static final int PARLIST=18;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int METHOD_LIST=14;
    public static final int T__33=33;
    public static final int WS=26;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int PARLIST_DECL=19;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int BLOCK=13;
    public static final int ASSIGNMENT=21;
    public static final int REACTION=7;

    // delegates
    // delegators


        public TBPTree(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public TBPTree(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return TBPTree.tokenNames; }
    public String getGrammarFileName() { return "src\\grammars\\TBPTree.g"; }


    /*    private Component component;

        public Component getComponent() {
            return component;
        }*/

        private ErrorCollector errorReporter = null;
        public void setErrorReporter(ErrorCollector errorReporter) {
            this.errorReporter = errorReporter;
        }
        public void emitErrorMessage(String msg) {
    	if (errorReporter!=null){
    	    errorReporter.addError(msg);
    	} else {
    	    super.emitErrorMessage(msg);	
    	}
        }




    // $ANTLR start "component"
    // src\\grammars\\TBPTree.g:49:1: component returns [ParserResult value] : ^( 'component' IDF ^( 'types' ( type )* ) ^( 'vars' ( var )* ) ^( 'provisions' ( provision )* ) ^( 'reactions' ( reaction )* ) ^( 'threads' ( thread )* ) ) ;
    public final ParserResult component() throws RecognitionException {
        ParserResult value = null;

        CommonTree IDF1=null;
        EnumerationType type2 = null;

        TBPVariableDefinition var3 = null;

        TBPProvisionContainerNode<String> provision4 = null;

        TBPMethodDeclaration<String> reaction5 = null;

        TBPThreadContainerNode thread6 = null;


         
        	List<EnumerationType> types = new ArrayList<EnumerationType>();
        	List<TBPVariableDefinition<String>> defs = new
                ArrayList<TBPVariableDefinition<String>>();
        	List<TBPProvisionContainerNode<String>> provs = new
                ArrayList<TBPProvisionContainerNode<String>>();
        	List<TBPMethodDeclaration<String>> reacts = new ArrayList<TBPMethodDeclaration<String>>();
        	List<TBPThreadContainerNode<String>> threads = new
                ArrayList<TBPThreadContainerNode<String>>();
        	String name = null;

        try {
            // src\\grammars\\TBPTree.g:61:2: ( ^( 'component' IDF ^( 'types' ( type )* ) ^( 'vars' ( var )* ) ^( 'provisions' ( provision )* ) ^( 'reactions' ( reaction )* ) ^( 'threads' ( thread )* ) ) )
            // src\\grammars\\TBPTree.g:61:5: ^( 'component' IDF ^( 'types' ( type )* ) ^( 'vars' ( var )* ) ^( 'provisions' ( provision )* ) ^( 'reactions' ( reaction )* ) ^( 'threads' ( thread )* ) )
            {
            match(input,28,FOLLOW_28_in_component50); 

            match(input, Token.DOWN, null); 
            IDF1=(CommonTree)match(input,IDF,FOLLOW_IDF_in_component52); 
            name=(IDF1!=null?IDF1.getText():null);
            match(input,30,FOLLOW_30_in_component76); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:62:35: ( type )*
                loop1:
                do {
                    int alt1=2;
                    int LA1_0 = input.LA(1);

                    if ( (LA1_0==TYPEDEF) ) {
                        alt1=1;
                    }


                    switch (alt1) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:62:36: type
                	    {
                	    pushFollow(FOLLOW_type_in_component84);
                	    type2=type();

                	    state._fsp--;

                	    types.add(type2);

                	    }
                	    break;

                	default :
                	    break loop1;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
            match(input,33,FOLLOW_33_in_component122); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:63:42: ( var )*
                loop2:
                do {
                    int alt2=2;
                    int LA2_0 = input.LA(1);

                    if ( (LA2_0==VARDEF) ) {
                        alt2=1;
                    }


                    switch (alt2) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:63:43: var
                	    {
                	    pushFollow(FOLLOW_var_in_component131);
                	    var3=var();

                	    state._fsp--;

                	    defs.add(var3);

                	    }
                	    break;

                	default :
                	    break loop2;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
            match(input,34,FOLLOW_34_in_component167); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:64:42: ( provision )*
                loop3:
                do {
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( (LA3_0==PROVISION) ) {
                        alt3=1;
                    }


                    switch (alt3) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:64:43: provision
                	    {
                	    pushFollow(FOLLOW_provision_in_component170);
                	    provision4=provision();

                	    state._fsp--;

                	    provs.add(provision4);

                	    }
                	    break;

                	default :
                	    break loop3;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
            match(input,35,FOLLOW_35_in_component205); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:65:42: ( reaction )*
                loop4:
                do {
                    int alt4=2;
                    int LA4_0 = input.LA(1);

                    if ( (LA4_0==REACTION) ) {
                        alt4=1;
                    }


                    switch (alt4) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:65:43: reaction
                	    {
                	    pushFollow(FOLLOW_reaction_in_component209);
                	    reaction5=reaction();

                	    state._fsp--;

                	    reacts.add(reaction5);

                	    }
                	    break;

                	default :
                	    break loop4;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
            match(input,36,FOLLOW_36_in_component245); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:66:42: ( thread )*
                loop5:
                do {
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( (LA5_0==THREAD) ) {
                        alt5=1;
                    }


                    switch (alt5) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:66:43: thread
                	    {
                	    pushFollow(FOLLOW_thread_in_component251);
                	    thread6=thread();

                	    state._fsp--;

                	    threads.add(thread6);

                	    }
                	    break;

                	default :
                	    break loop5;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
             
                    //component = new Component(name, types);
                    value = new ParserResult(
                                 new TBPSpecification(name, defs, provs, reacts, threads),
                                 types);
                
        }
        return value;
    }
    // $ANTLR end "component"


    // $ANTLR start "type"
    // src\\grammars\\TBPTree.g:76:1: type returns [EnumerationType value] : ^( TYPEDEF name= IDF (v= IDF )+ ) ;
    public final EnumerationType type() throws RecognitionException {
        EnumerationType value = null;

        CommonTree name=null;
        CommonTree v=null;

         List<String> vals = new ArrayList<String>(); 
        try {
            // src\\grammars\\TBPTree.g:78:2: ( ^( TYPEDEF name= IDF (v= IDF )+ ) )
            // src\\grammars\\TBPTree.g:78:5: ^( TYPEDEF name= IDF (v= IDF )+ )
            {
            match(input,TYPEDEF,FOLLOW_TYPEDEF_in_type335); 

            match(input, Token.DOWN, null); 
            name=(CommonTree)match(input,IDF,FOLLOW_IDF_in_type339); 
            // src\\grammars\\TBPTree.g:78:24: (v= IDF )+
            int cnt6=0;
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==IDF) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:78:25: v= IDF
            	    {
            	    v=(CommonTree)match(input,IDF,FOLLOW_IDF_in_type344); 
            	    vals.add((v!=null?v.getText():null));

            	    }
            	    break;

            	default :
            	    if ( cnt6 >= 1 ) break loop6;
                        EarlyExitException eee =
                            new EarlyExitException(6, input);
                        throw eee;
                }
                cnt6++;
            } while (true);


            match(input, Token.UP, null); 

            	     		value = new EnumerationType((name!=null?name.getText():null), vals); 
            	     	

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "type"


    // $ANTLR start "var"
    // src\\grammars\\TBPTree.g:84:1: var returns [TBPVariableDefinition value] : ( ^( VARDEF a= IDF b= IDF c= IDF ) | ^( VARDEF IDF ) );
    public final TBPVariableDefinition var() throws RecognitionException {
        TBPVariableDefinition value = null;

        CommonTree a=null;
        CommonTree b=null;
        CommonTree c=null;
        CommonTree IDF7=null;

        try {
            // src\\grammars\\TBPTree.g:85:2: ( ^( VARDEF a= IDF b= IDF c= IDF ) | ^( VARDEF IDF ) )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==VARDEF) ) {
                int LA7_1 = input.LA(2);

                if ( (LA7_1==DOWN) ) {
                    int LA7_2 = input.LA(3);

                    if ( (LA7_2==IDF) ) {
                        int LA7_3 = input.LA(4);

                        if ( (LA7_3==IDF) ) {
                            alt7=1;
                        }
                        else if ( (LA7_3==UP) ) {
                            alt7=2;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("", 7, 3, input);

                            throw nvae;
                        }
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 7, 2, input);

                        throw nvae;
                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // src\\grammars\\TBPTree.g:85:4: ^( VARDEF a= IDF b= IDF c= IDF )
                    {
                    match(input,VARDEF,FOLLOW_VARDEF_in_var386); 

                    match(input, Token.DOWN, null); 
                    a=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var390); 
                    b=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var394); 
                    c=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var398); 

                    match(input, Token.UP, null); 
                     value = new TBPVariableDefinition((a!=null?a.getText():null),(b!=null?b.getText():null),(c!=null?c.getText():null)); 

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:87:4: ^( VARDEF IDF )
                    {
                    match(input,VARDEF,FOLLOW_VARDEF_in_var409); 

                    match(input, Token.DOWN, null); 
                    IDF7=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var411); 

                    match(input, Token.UP, null); 
                     value = new TBPVariableDefinition((IDF7!=null?IDF7.getText():null)); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "var"


    // $ANTLR start "var_decl"
    // src\\grammars\\TBPTree.g:90:1: var_decl returns [TBPVariableDefinition value] : ^( VARDEF a= IDF b= IDF c= IDF ) ;
    public final TBPVariableDefinition var_decl() throws RecognitionException {
        TBPVariableDefinition value = null;

        CommonTree a=null;
        CommonTree b=null;
        CommonTree c=null;

        try {
            // src\\grammars\\TBPTree.g:91:2: ( ^( VARDEF a= IDF b= IDF c= IDF ) )
            // src\\grammars\\TBPTree.g:91:4: ^( VARDEF a= IDF b= IDF c= IDF )
            {
            match(input,VARDEF,FOLLOW_VARDEF_in_var_decl432); 

            match(input, Token.DOWN, null); 
            a=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var_decl436); 
            b=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var_decl440); 
            c=(CommonTree)match(input,IDF,FOLLOW_IDF_in_var_decl444); 

            match(input, Token.UP, null); 
            value = new TBPVariableDefinition((a!=null?a.getText():null),(b!=null?b.getText():null),(c!=null?c.getText():null));

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "var_decl"


    // $ANTLR start "provision"
    // src\\grammars\\TBPTree.g:95:1: provision returns [TBPProvisionContainerNode<String> value] : ^( PROVISION p_exp method_list ( IDF )? ) ;
    public final TBPProvisionContainerNode<String> provision() throws RecognitionException {
        TBPProvisionContainerNode<String> value = null;

        CommonTree IDF9=null;
        TBPProvisionNode<String> p_exp8 = null;

        Set<String> method_list10 = null;


        try {
            // src\\grammars\\TBPTree.g:96:2: ( ^( PROVISION p_exp method_list ( IDF )? ) )
            // src\\grammars\\TBPTree.g:96:4: ^( PROVISION p_exp method_list ( IDF )? )
            {
            match(input,PROVISION,FOLLOW_PROVISION_in_provision467); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_p_exp_in_provision469);
            p_exp8=p_exp();

            state._fsp--;

            pushFollow(FOLLOW_method_list_in_provision471);
            method_list10=method_list();

            state._fsp--;

            // src\\grammars\\TBPTree.g:96:34: ( IDF )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==IDF) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // src\\grammars\\TBPTree.g:96:34: IDF
                    {
                    IDF9=(CommonTree)match(input,IDF,FOLLOW_IDF_in_provision473); 

                    }
                    break;

            }


            match(input, Token.UP, null); 

             			
            			TBPProvisionContainerNode<String> val = new TBPProvisionContainerNode<String>(p_exp8,(IDF9!=null?IDF9.getText():null)); 
            			val.setFilter(method_list10);
             			value = val;
                                    
             		

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "provision"


    // $ANTLR start "method_list"
    // src\\grammars\\TBPTree.g:105:1: method_list returns [Set<String> value] : ^( METHOD_LIST ( method_list_element )* ) ;
    public final Set<String> method_list() throws RecognitionException {
        Set<String> value = null;

        String method_list_element11 = null;


         value = new HashSet<String>(); 
        try {
            // src\\grammars\\TBPTree.g:107:2: ( ^( METHOD_LIST ( method_list_element )* ) )
            // src\\grammars\\TBPTree.g:107:4: ^( METHOD_LIST ( method_list_element )* )
            {
            match(input,METHOD_LIST,FOLLOW_METHOD_LIST_in_method_list503); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:107:18: ( method_list_element )*
                loop9:
                do {
                    int alt9=2;
                    int LA9_0 = input.LA(1);

                    if ( (LA9_0==METHOD_LIST_ELEMENT) ) {
                        alt9=1;
                    }


                    switch (alt9) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:107:19: method_list_element
                	    {
                	    pushFollow(FOLLOW_method_list_element_in_method_list506);
                	    method_list_element11=method_list_element();

                	    state._fsp--;

                	    value.add(method_list_element11);

                	    }
                	    break;

                	default :
                	    break loop9;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "method_list"


    // $ANTLR start "method_list_element"
    // src\\grammars\\TBPTree.g:110:1: method_list_element returns [String value] : ( ^( METHOD_LIST_ELEMENT '*' ) | ^( METHOD_LIST_ELEMENT IDF '*' ) | ^( METHOD_LIST_ELEMENT i= IDF m= IDF ) );
    public final String method_list_element() throws RecognitionException {
        String value = null;

        CommonTree i=null;
        CommonTree m=null;
        CommonTree IDF12=null;

        try {
            // src\\grammars\\TBPTree.g:111:2: ( ^( METHOD_LIST_ELEMENT '*' ) | ^( METHOD_LIST_ELEMENT IDF '*' ) | ^( METHOD_LIST_ELEMENT i= IDF m= IDF ) )
            int alt10=3;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==METHOD_LIST_ELEMENT) ) {
                int LA10_1 = input.LA(2);

                if ( (LA10_1==DOWN) ) {
                    int LA10_2 = input.LA(3);

                    if ( (LA10_2==44) ) {
                        alt10=1;
                    }
                    else if ( (LA10_2==IDF) ) {
                        int LA10_4 = input.LA(4);

                        if ( (LA10_4==44) ) {
                            alt10=2;
                        }
                        else if ( (LA10_4==IDF) ) {
                            alt10=3;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("", 10, 4, input);

                            throw nvae;
                        }
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 10, 2, input);

                        throw nvae;
                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 10, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // src\\grammars\\TBPTree.g:111:4: ^( METHOD_LIST_ELEMENT '*' )
                    {
                    match(input,METHOD_LIST_ELEMENT,FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element530); 

                    match(input, Token.DOWN, null); 
                    match(input,44,FOLLOW_44_in_method_list_element532); 

                    match(input, Token.UP, null); 
                    value = "*";

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:112:4: ^( METHOD_LIST_ELEMENT IDF '*' )
                    {
                    match(input,METHOD_LIST_ELEMENT,FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element541); 

                    match(input, Token.DOWN, null); 
                    IDF12=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_list_element543); 
                    match(input,44,FOLLOW_44_in_method_list_element545); 

                    match(input, Token.UP, null); 

                    		value = (IDF12!=null?IDF12.getText():null)+".*";

                    }
                    break;
                case 3 :
                    // src\\grammars\\TBPTree.g:114:4: ^( METHOD_LIST_ELEMENT i= IDF m= IDF )
                    {
                    match(input,METHOD_LIST_ELEMENT,FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element554); 

                    match(input, Token.DOWN, null); 
                    i=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_list_element558); 
                    m=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_list_element562); 

                    match(input, Token.UP, null); 
                    value = (i!=null?i.getText():null)+"."+(m!=null?m.getText():null);

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "method_list_element"


    // $ANTLR start "reaction"
    // src\\grammars\\TBPTree.g:117:1: reaction returns [TBPMethodDeclaration<String> value] : ^( REACTION method_decl (a= annotation )? ) ;
    public final TBPMethodDeclaration<String> reaction() throws RecognitionException {
        TBPMethodDeclaration<String> value = null;

        Annotation a = null;

        TBPMethodDeclaration<String> method_decl13 = null;


        try {
            // src\\grammars\\TBPTree.g:118:2: ( ^( REACTION method_decl (a= annotation )? ) )
            // src\\grammars\\TBPTree.g:118:4: ^( REACTION method_decl (a= annotation )? )
            {
            match(input,REACTION,FOLLOW_REACTION_in_reaction581); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_method_decl_in_reaction583);
            method_decl13=method_decl();

            state._fsp--;

            // src\\grammars\\TBPTree.g:118:27: (a= annotation )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==ANNOTATION) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // src\\grammars\\TBPTree.g:118:28: a= annotation
                    {
                    pushFollow(FOLLOW_annotation_in_reaction588);
                    a=annotation();

                    state._fsp--;


                    }
                    break;

            }


            match(input, Token.UP, null); 
             value = method_decl13;  
            	 	  if(a != null){
            	 	  	value.setAnnotation(a);
            	 	  }
            	 	

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "reaction"


    // $ANTLR start "thread"
    // src\\grammars\\TBPTree.g:125:1: thread returns [TBPThreadContainerNode value] : ^( THREAD 'vars' ( var_decl )* block ( IDF )? ) ;
    public final TBPThreadContainerNode thread() throws RecognitionException {
        TBPThreadContainerNode value = null;

        CommonTree IDF15=null;
        TBPVariableDefinition var_decl14 = null;

        TBPImperativeNode<String> block16 = null;



        	List<TBPVariableDefinition<String>> defs = new
                ArrayList<TBPVariableDefinition<String>>();

        try {
            // src\\grammars\\TBPTree.g:130:2: ( ^( THREAD 'vars' ( var_decl )* block ( IDF )? ) )
            // src\\grammars\\TBPTree.g:130:4: ^( THREAD 'vars' ( var_decl )* block ( IDF )? )
            {
            match(input,THREAD,FOLLOW_THREAD_in_thread617); 

            match(input, Token.DOWN, null); 
            match(input,33,FOLLOW_33_in_thread622); 
            // src\\grammars\\TBPTree.g:131:10: ( var_decl )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==VARDEF) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:131:11: var_decl
            	    {
            	    pushFollow(FOLLOW_var_decl_in_thread625);
            	    var_decl14=var_decl();

            	    state._fsp--;

            	    defs.add(var_decl14);

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            pushFollow(FOLLOW_block_in_thread634);
            block16=block();

            state._fsp--;

            // src\\grammars\\TBPTree.g:133:3: ( IDF )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==IDF) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // src\\grammars\\TBPTree.g:133:3: IDF
                    {
                    IDF15=(CommonTree)match(input,IDF,FOLLOW_IDF_in_thread639); 

                    }
                    break;

            }


            match(input, Token.UP, null); 
             value = new TBPThreadContainerNode((IDF15!=null?IDF15.getText():null), block16, defs); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "thread"


    // $ANTLR start "annotation"
    // src\\grammars\\TBPTree.g:136:1: annotation returns [ Annotation value ] : ^( ANNOTATION name= IDF (k= IDF v= IDF )* ) ;
    public final Annotation annotation() throws RecognitionException {
        Annotation value = null;

        CommonTree name=null;
        CommonTree k=null;
        CommonTree v=null;

         List<String> keys = new ArrayList<String>(), vals = new ArrayList<String>(); 
        try {
            // src\\grammars\\TBPTree.g:138:5: ( ^( ANNOTATION name= IDF (k= IDF v= IDF )* ) )
            // src\\grammars\\TBPTree.g:138:7: ^( ANNOTATION name= IDF (k= IDF v= IDF )* )
            {
            match(input,ANNOTATION,FOLLOW_ANNOTATION_in_annotation669); 

            match(input, Token.DOWN, null); 
            name=(CommonTree)match(input,IDF,FOLLOW_IDF_in_annotation673); 
            // src\\grammars\\TBPTree.g:139:11: (k= IDF v= IDF )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( (LA14_0==IDF) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:139:12: k= IDF v= IDF
            	    {
            	    k=(CommonTree)match(input,IDF,FOLLOW_IDF_in_annotation689); 
            	    v=(CommonTree)match(input,IDF,FOLLOW_IDF_in_annotation693); 
            	     keys.add((k!=null?k.getText():null)); vals.add((v!=null?v.getText():null)); 

            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);


            match(input, Token.UP, null); 
             
            	 	  value = new Annotation((name!=null?name.getText():null), keys, vals);
            	 	

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "annotation"


    // $ANTLR start "p_exp"
    // src\\grammars\\TBPTree.g:147:1: p_exp returns [TBPProvisionNode<String> value] : ( ^( '+' a= p_exp b= p_exp ) | ^( ';' a= p_exp b= p_exp ) | ^( '|' a= p_exp b= p_exp ) | ^( '||' a= p_exp b= p_exp ) | ^( '*' a= p_exp ) | ^( '|*' a= p_exp ) | ^( '|' d= DIGITS b= p_exp ) | ^( '||' d= DIGITS b= p_exp ) | ^( EVENT (m= method_call )? ( IDF )? ) | ^( ANN_PROVISION annotation inner= p_exp ) );
    public final TBPProvisionNode<String> p_exp() throws RecognitionException {
        TBPProvisionNode<String> value = null;

        CommonTree d=null;
        CommonTree IDF17=null;
        TBPProvisionNode<String> a = null;

        TBPProvisionNode<String> b = null;

        MethodCall m = null;

        TBPProvisionNode<String> inner = null;

        Annotation annotation18 = null;


        try {
            // src\\grammars\\TBPTree.g:147:47: ( ^( '+' a= p_exp b= p_exp ) | ^( ';' a= p_exp b= p_exp ) | ^( '|' a= p_exp b= p_exp ) | ^( '||' a= p_exp b= p_exp ) | ^( '*' a= p_exp ) | ^( '|*' a= p_exp ) | ^( '|' d= DIGITS b= p_exp ) | ^( '||' d= DIGITS b= p_exp ) | ^( EVENT (m= method_call )? ( IDF )? ) | ^( ANN_PROVISION annotation inner= p_exp ) )
            int alt17=10;
            alt17 = dfa17.predict(input);
            switch (alt17) {
                case 1 :
                    // src\\grammars\\TBPTree.g:148:4: ^( '+' a= p_exp b= p_exp )
                    {
                    match(input,46,FOLLOW_46_in_p_exp732); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp737);
                    a=p_exp();

                    state._fsp--;

                    pushFollow(FOLLOW_p_exp_in_p_exp741);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPAlternative<String> (a,b); 

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:149:4: ^( ';' a= p_exp b= p_exp )
                    {
                    match(input,31,FOLLOW_31_in_p_exp750); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp755);
                    a=p_exp();

                    state._fsp--;

                    pushFollow(FOLLOW_p_exp_in_p_exp759);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPSequence<String> (a,b); 

                    }
                    break;
                case 3 :
                    // src\\grammars\\TBPTree.g:150:4: ^( '|' a= p_exp b= p_exp )
                    {
                    match(input,47,FOLLOW_47_in_p_exp770); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp775);
                    a=p_exp();

                    state._fsp--;

                    pushFollow(FOLLOW_p_exp_in_p_exp779);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPParallel<String> (a,b); 

                    }
                    break;
                case 4 :
                    // src\\grammars\\TBPTree.g:151:4: ^( '||' a= p_exp b= p_exp )
                    {
                    match(input,48,FOLLOW_48_in_p_exp789); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp793);
                    a=p_exp();

                    state._fsp--;

                    pushFollow(FOLLOW_p_exp_in_p_exp797);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPParallelOr<String> (a,b); 

                    }
                    break;
                case 5 :
                    // src\\grammars\\TBPTree.g:152:4: ^( '*' a= p_exp )
                    {
                    match(input,44,FOLLOW_44_in_p_exp807); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp812);
                    a=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPRepetition<String> (a); 

                    }
                    break;
                case 6 :
                    // src\\grammars\\TBPTree.g:153:4: ^( '|*' a= p_exp )
                    {
                    match(input,49,FOLLOW_49_in_p_exp830); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_p_exp_in_p_exp834);
                    a=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPUnlimitedReentrancy<String> (a); 

                    }
                    break;
                case 7 :
                    // src\\grammars\\TBPTree.g:154:4: ^( '|' d= DIGITS b= p_exp )
                    {
                    match(input,47,FOLLOW_47_in_p_exp852); 

                    match(input, Token.DOWN, null); 
                    d=(CommonTree)match(input,DIGITS,FOLLOW_DIGITS_in_p_exp857); 
                    pushFollow(FOLLOW_p_exp_in_p_exp861);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPLimitedReentrancy<String> (b, Integer.parseInt((d!=null?d.getText():null))); 

                    }
                    break;
                case 8 :
                    // src\\grammars\\TBPTree.g:155:4: ^( '||' d= DIGITS b= p_exp )
                    {
                    match(input,48,FOLLOW_48_in_p_exp869); 

                    match(input, Token.DOWN, null); 
                    d=(CommonTree)match(input,DIGITS,FOLLOW_DIGITS_in_p_exp874); 
                    pushFollow(FOLLOW_p_exp_in_p_exp878);
                    b=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPLimitedReentrancy<String> (b, Integer.parseInt((d!=null?d.getText():null))); 

                    }
                    break;
                case 9 :
                    // src\\grammars\\TBPTree.g:156:4: ^( EVENT (m= method_call )? ( IDF )? )
                    {
                    match(input,EVENT,FOLLOW_EVENT_in_p_exp886); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        // src\\grammars\\TBPTree.g:156:12: (m= method_call )?
                        int alt15=2;
                        int LA15_0 = input.LA(1);

                        if ( (LA15_0==METHOD_CALL) ) {
                            alt15=1;
                        }
                        switch (alt15) {
                            case 1 :
                                // src\\grammars\\TBPTree.g:156:13: m= method_call
                                {
                                pushFollow(FOLLOW_method_call_in_p_exp891);
                                m=method_call();

                                state._fsp--;


                                }
                                break;

                        }

                        // src\\grammars\\TBPTree.g:156:29: ( IDF )?
                        int alt16=2;
                        int LA16_0 = input.LA(1);

                        if ( (LA16_0==IDF) ) {
                            alt16=1;
                        }
                        switch (alt16) {
                            case 1 :
                                // src\\grammars\\TBPTree.g:156:29: IDF
                                {
                                IDF17=(CommonTree)match(input,IDF,FOLLOW_IDF_in_p_exp895); 

                                }
                                break;

                        }


                        match(input, Token.UP, null); 
                    }
                     
                    		  if(m != null)
                    			value = new TBPAccept<String>(m,(IDF17!=null?IDF17.getText():null));
                    		  else 
                    		  	value = new TBPProvisionNull<String>();
                    		

                    }
                    break;
                case 10 :
                    // src\\grammars\\TBPTree.g:163:4: ^( ANN_PROVISION annotation inner= p_exp )
                    {
                    match(input,ANN_PROVISION,FOLLOW_ANN_PROVISION_in_p_exp907); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_annotation_in_p_exp909);
                    annotation18=annotation();

                    state._fsp--;

                    pushFollow(FOLLOW_p_exp_in_p_exp913);
                    inner=p_exp();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     
                    	      value = inner;
                    	      value.setAnnotation(annotation18);
                    	    

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "p_exp"


    // $ANTLR start "method_decl"
    // src\\grammars\\TBPTree.g:170:1: method_decl returns [ TBPMethodDeclaration<String> value ] : ^( METHOD_DECL itf_= IDF meth_= IDF ^( PARLIST_DECL (pt= IDF p= IDF )* ) (ret_type= IDF )? ) 'vars' ( var_decl )* block ;
    public final TBPMethodDeclaration<String> method_decl() throws RecognitionException {
        TBPMethodDeclaration<String> value = null;

        CommonTree itf_=null;
        CommonTree meth_=null;
        CommonTree pt=null;
        CommonTree p=null;
        CommonTree ret_type=null;
        TBPVariableDefinition var_decl19 = null;

        TBPImperativeNode<String> block20 = null;



        	LinkedHashMap<String,String> params = new LinkedHashMap<String,String>();
        	List<String> param_names = new ArrayList<String>();
        	List<TBPVariableDefinition<String>> defs = new
                ArrayList<TBPVariableDefinition<String>>();

        try {
            // src\\grammars\\TBPTree.g:177:2: ( ^( METHOD_DECL itf_= IDF meth_= IDF ^( PARLIST_DECL (pt= IDF p= IDF )* ) (ret_type= IDF )? ) 'vars' ( var_decl )* block )
            // src\\grammars\\TBPTree.g:177:4: ^( METHOD_DECL itf_= IDF meth_= IDF ^( PARLIST_DECL (pt= IDF p= IDF )* ) (ret_type= IDF )? ) 'vars' ( var_decl )* block
            {
            match(input,METHOD_DECL,FOLLOW_METHOD_DECL_in_method_decl943); 

            match(input, Token.DOWN, null); 
            itf_=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_decl947); 
            meth_=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_decl951); 
            match(input,PARLIST_DECL,FOLLOW_PARLIST_DECL_in_method_decl958); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:178:19: (pt= IDF p= IDF )*
                loop18:
                do {
                    int alt18=2;
                    int LA18_0 = input.LA(1);

                    if ( (LA18_0==IDF) ) {
                        alt18=1;
                    }


                    switch (alt18) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:178:20: pt= IDF p= IDF
                	    {
                	    pt=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_decl963); 
                	    p=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_decl967); 
                	    params.put((p!=null?p.getText():null),(pt!=null?pt.getText():null));param_names.add((p!=null?p.getText():null));

                	    }
                	    break;

                	default :
                	    break loop18;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
            // src\\grammars\\TBPTree.g:179:12: (ret_type= IDF )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==IDF) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // src\\grammars\\TBPTree.g:179:12: ret_type= IDF
                    {
                    ret_type=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_decl981); 

                    }
                    break;

            }


            match(input, Token.UP, null); 
            match(input,33,FOLLOW_33_in_method_decl988); 
            // src\\grammars\\TBPTree.g:180:11: ( var_decl )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);

                if ( (LA20_0==VARDEF) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:180:12: var_decl
            	    {
            	    pushFollow(FOLLOW_var_decl_in_method_decl991);
            	    var_decl19=var_decl();

            	    state._fsp--;

            	    defs.add(var_decl19);

            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);

            pushFollow(FOLLOW_block_in_method_decl1001);
            block20=block();

            state._fsp--;

             value = new TBPMethodDeclaration<String>((itf_!=null?itf_.getText():null), (meth_!=null?meth_.getText():null),
                            new MethodSignature<String>(
                                params, (ret_type!=null?ret_type.getText():null)), block20, defs); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "method_decl"


    // $ANTLR start "block"
    // src\\grammars\\TBPTree.g:188:1: block returns [TBPImperativeNode<String> value] : ( ^( ';' s1= block s2= block ) | ^( 'switch' val body ) | ^( SWITCH_ND nd_body ) | ^( 'while' cond b= block ) | ^( 'if' cond b1= block (b2= block )? ) | ^( 'sync' IDF b= block ) | ^( 'wait' IDF ) | ^( ASSIGNMENT IDF val ) | ^( RETURN ( IDF )? ) | ^( BLOCK b= block ) | ^( 'NULL' empty ) | method_call | ^( ANN_STATEMENT annotation inner= block ) );
    public final TBPImperativeNode<String> block() throws RecognitionException {
        TBPImperativeNode<String> value = null;

        CommonTree IDF26=null;
        CommonTree IDF27=null;
        CommonTree IDF28=null;
        CommonTree IDF30=null;
        TBPImperativeNode<String> s1 = null;

        TBPImperativeNode<String> s2 = null;

        TBPImperativeNode<String> b = null;

        TBPImperativeNode<String> b1 = null;

        TBPImperativeNode<String> b2 = null;

        TBPImperativeNode<String> inner = null;

        TBPValue<String> val21 = null;

        TBPTree.body_return body22 = null;

        List<TBPImperativeNode<String>> nd_body23 = null;

        ITBPCondition<String> cond24 = null;

        ITBPCondition<String> cond25 = null;

        TBPValue<String> val29 = null;

        MethodCall method_call31 = null;

        Annotation annotation32 = null;


        try {
            // src\\grammars\\TBPTree.g:189:2: ( ^( ';' s1= block s2= block ) | ^( 'switch' val body ) | ^( SWITCH_ND nd_body ) | ^( 'while' cond b= block ) | ^( 'if' cond b1= block (b2= block )? ) | ^( 'sync' IDF b= block ) | ^( 'wait' IDF ) | ^( ASSIGNMENT IDF val ) | ^( RETURN ( IDF )? ) | ^( BLOCK b= block ) | ^( 'NULL' empty ) | method_call | ^( ANN_STATEMENT annotation inner= block ) )
            int alt23=13;
            switch ( input.LA(1) ) {
            case 31:
                {
                alt23=1;
                }
                break;
            case 52:
                {
                alt23=2;
                }
                break;
            case SWITCH_ND:
                {
                alt23=3;
                }
                break;
            case 56:
                {
                alt23=4;
                }
                break;
            case 57:
                {
                alt23=5;
                }
                break;
            case 59:
                {
                alt23=6;
                }
                break;
            case 60:
                {
                alt23=7;
                }
                break;
            case ASSIGNMENT:
                {
                alt23=8;
                }
                break;
            case RETURN:
                {
                alt23=9;
                }
                break;
            case BLOCK:
                {
                alt23=10;
                }
                break;
            case 51:
                {
                alt23=11;
                }
                break;
            case METHOD_CALL:
                {
                alt23=12;
                }
                break;
            case ANN_STATEMENT:
                {
                alt23=13;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }

            switch (alt23) {
                case 1 :
                    // src\\grammars\\TBPTree.g:189:4: ^( ';' s1= block s2= block )
                    {
                    match(input,31,FOLLOW_31_in_block1023); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_block_in_block1027);
                    s1=block();

                    state._fsp--;

                    pushFollow(FOLLOW_block_in_block1031);
                    s2=block();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPImperativeSequence<String>(s1,s2); 

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:190:4: ^( 'switch' val body )
                    {
                    match(input,52,FOLLOW_52_in_block1040); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_val_in_block1042);
                    val21=val();

                    state._fsp--;

                    pushFollow(FOLLOW_body_in_block1044);
                    body22=body();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPSwitch<String>(val21,(body22!=null?body22.branches:null),(body22!=null?body22.cases:null)); 

                    }
                    break;
                case 3 :
                    // src\\grammars\\TBPTree.g:191:4: ^( SWITCH_ND nd_body )
                    {
                    match(input,SWITCH_ND,FOLLOW_SWITCH_ND_in_block1057); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_nd_body_in_block1059);
                    nd_body23=nd_body();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPSwitch<String>(nd_body23); 

                    }
                    break;
                case 4 :
                    // src\\grammars\\TBPTree.g:192:4: ^( 'while' cond b= block )
                    {
                    match(input,56,FOLLOW_56_in_block1072); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_cond_in_block1074);
                    cond24=cond();

                    state._fsp--;

                    pushFollow(FOLLOW_block_in_block1078);
                    b=block();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPWhile<String>(cond24, b); 

                    }
                    break;
                case 5 :
                    // src\\grammars\\TBPTree.g:193:4: ^( 'if' cond b1= block (b2= block )? )
                    {
                    match(input,57,FOLLOW_57_in_block1088); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_cond_in_block1090);
                    cond25=cond();

                    state._fsp--;

                    pushFollow(FOLLOW_block_in_block1094);
                    b1=block();

                    state._fsp--;

                    // src\\grammars\\TBPTree.g:193:27: (b2= block )?
                    int alt21=2;
                    int LA21_0 = input.LA(1);

                    if ( (LA21_0==ANN_STATEMENT||LA21_0==BLOCK||LA21_0==METHOD_CALL||(LA21_0>=ASSIGNMENT && LA21_0<=SWITCH_ND)||LA21_0==31||(LA21_0>=51 && LA21_0<=52)||(LA21_0>=56 && LA21_0<=57)||(LA21_0>=59 && LA21_0<=60)) ) {
                        alt21=1;
                    }
                    switch (alt21) {
                        case 1 :
                            // src\\grammars\\TBPTree.g:193:27: b2= block
                            {
                            pushFollow(FOLLOW_block_in_block1098);
                            b2=block();

                            state._fsp--;


                            }
                            break;

                    }


                    match(input, Token.UP, null); 
                     value = new TBPIf<String>(cond25, b1, b2); 

                    }
                    break;
                case 6 :
                    // src\\grammars\\TBPTree.g:194:4: ^( 'sync' IDF b= block )
                    {
                    match(input,59,FOLLOW_59_in_block1108); 

                    match(input, Token.DOWN, null); 
                    IDF26=(CommonTree)match(input,IDF,FOLLOW_IDF_in_block1110); 
                    pushFollow(FOLLOW_block_in_block1114);
                    b=block();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPSync<String>((IDF26!=null?IDF26.getText():null), b); 

                    }
                    break;
                case 7 :
                    // src\\grammars\\TBPTree.g:195:4: ^( 'wait' IDF )
                    {
                    match(input,60,FOLLOW_60_in_block1126); 

                    match(input, Token.DOWN, null); 
                    IDF27=(CommonTree)match(input,IDF,FOLLOW_IDF_in_block1128); 

                    match(input, Token.UP, null); 
                     value = new TBPWait<String>((IDF27!=null?IDF27.getText():null)); 

                    }
                    break;
                case 8 :
                    // src\\grammars\\TBPTree.g:196:4: ^( ASSIGNMENT IDF val )
                    {
                    match(input,ASSIGNMENT,FOLLOW_ASSIGNMENT_in_block1141); 

                    match(input, Token.DOWN, null); 
                    IDF28=(CommonTree)match(input,IDF,FOLLOW_IDF_in_block1143); 
                    pushFollow(FOLLOW_val_in_block1145);
                    val29=val();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = new TBPAssignment<String>((IDF28!=null?IDF28.getText():null),val29); 

                    }
                    break;
                case 9 :
                    // src\\grammars\\TBPTree.g:197:4: ^( RETURN ( IDF )? )
                    {
                    match(input,RETURN,FOLLOW_RETURN_in_block1157); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        // src\\grammars\\TBPTree.g:197:13: ( IDF )?
                        int alt22=2;
                        int LA22_0 = input.LA(1);

                        if ( (LA22_0==IDF) ) {
                            alt22=1;
                        }
                        switch (alt22) {
                            case 1 :
                                // src\\grammars\\TBPTree.g:197:13: IDF
                                {
                                IDF30=(CommonTree)match(input,IDF,FOLLOW_IDF_in_block1159); 

                                }
                                break;

                        }


                        match(input, Token.UP, null); 
                    }
                     value = new TBPReturn<String>((IDF30!=null?IDF30.getText():null)); 

                    }
                    break;
                case 10 :
                    // src\\grammars\\TBPTree.g:198:4: ^( BLOCK b= block )
                    {
                    match(input,BLOCK,FOLLOW_BLOCK_in_block1180); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_block_in_block1184);
                    b=block();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     value = b; 

                    }
                    break;
                case 11 :
                    // src\\grammars\\TBPTree.g:199:4: ^( 'NULL' empty )
                    {
                    match(input,51,FOLLOW_51_in_block1202); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        pushFollow(FOLLOW_empty_in_block1204);
                        empty();

                        state._fsp--;


                        match(input, Token.UP, null); 
                    }
                     value = new TBPImperativeNull<String>(); 

                    }
                    break;
                case 12 :
                    // src\\grammars\\TBPTree.g:200:4: method_call
                    {
                    pushFollow(FOLLOW_method_call_in_block1220);
                    method_call31=method_call();

                    state._fsp--;

                     value = new TBPEmit<String>(method_call31); 

                    }
                    break;
                case 13 :
                    // src\\grammars\\TBPTree.g:201:4: ^( ANN_STATEMENT annotation inner= block )
                    {
                    match(input,ANN_STATEMENT,FOLLOW_ANN_STATEMENT_in_block1241); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_annotation_in_block1243);
                    annotation32=annotation();

                    state._fsp--;

                    pushFollow(FOLLOW_block_in_block1247);
                    inner=block();

                    state._fsp--;


                    match(input, Token.UP, null); 

                    	    value = inner;
                    	    value.setAnnotation(annotation32);
                    	  

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "block"


    // $ANTLR start "empty"
    // src\\grammars\\TBPTree.g:208:1: empty : ;
    public final void empty() throws RecognitionException {
        try {
            // src\\grammars\\TBPTree.g:208:7: ()
            // src\\grammars\\TBPTree.g:208:9: 
            {
            }

        }
        finally {
        }
        return ;
    }
    // $ANTLR end "empty"

    public static class body_return extends TreeRuleReturnScope {
        public List<TBPImperativeNode<String>> branches;
        public List<String> cases;
    };

    // $ANTLR start "body"
    // src\\grammars\\TBPTree.g:210:1: body returns [List<TBPImperativeNode<String>> branches, List<String> cases] : ( ^( 'case' IDF b= block ) | ^( 'default' b2= block ) )+ ;
    public final TBPTree.body_return body() throws RecognitionException {
        TBPTree.body_return retval = new TBPTree.body_return();
        retval.start = input.LT(1);

        CommonTree IDF33=null;
        TBPImperativeNode<String> b = null;

        TBPImperativeNode<String> b2 = null;


         
        	retval.branches = new ArrayList<TBPImperativeNode<String>>(); 
        	retval.cases =  new ArrayList<String>();
              
        try {
            // src\\grammars\\TBPTree.g:215:2: ( ( ^( 'case' IDF b= block ) | ^( 'default' b2= block ) )+ )
            // src\\grammars\\TBPTree.g:215:5: ( ^( 'case' IDF b= block ) | ^( 'default' b2= block ) )+
            {
            // src\\grammars\\TBPTree.g:215:5: ( ^( 'case' IDF b= block ) | ^( 'default' b2= block ) )+
            int cnt24=0;
            loop24:
            do {
                int alt24=3;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==55) ) {
                    alt24=1;
                }
                else if ( (LA24_0==53) ) {
                    alt24=2;
                }


                switch (alt24) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:215:6: ^( 'case' IDF b= block )
            	    {
            	    match(input,55,FOLLOW_55_in_body1284); 

            	    match(input, Token.DOWN, null); 
            	    IDF33=(CommonTree)match(input,IDF,FOLLOW_IDF_in_body1286); 
            	    pushFollow(FOLLOW_block_in_body1290);
            	    b=block();

            	    state._fsp--;

            	     retval.branches.add(b); retval.cases.add((IDF33!=null?IDF33.getText():null)); 

            	    match(input, Token.UP, null); 

            	    }
            	    break;
            	case 2 :
            	    // src\\grammars\\TBPTree.g:216:8: ^( 'default' b2= block )
            	    {
            	    match(input,53,FOLLOW_53_in_body1304); 

            	    match(input, Token.DOWN, null); 
            	    pushFollow(FOLLOW_block_in_body1308);
            	    b2=block();

            	    state._fsp--;


            	    match(input, Token.UP, null); 
            	     retval.branches.add(b2); 

            	    }
            	    break;

            	default :
            	    if ( cnt24 >= 1 ) break loop24;
                        EarlyExitException eee =
                            new EarlyExitException(24, input);
                        throw eee;
                }
                cnt24++;
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "body"


    // $ANTLR start "nd_body"
    // src\\grammars\\TBPTree.g:219:1: nd_body returns [List<TBPImperativeNode<String>> branches] : ( ^( 'case' block ) )+ ;
    public final List<TBPImperativeNode<String>> nd_body() throws RecognitionException {
        List<TBPImperativeNode<String>> branches = null;

        TBPImperativeNode<String> block34 = null;


         branches = new ArrayList<TBPImperativeNode<String>>(); 
        try {
            // src\\grammars\\TBPTree.g:221:2: ( ( ^( 'case' block ) )+ )
            // src\\grammars\\TBPTree.g:221:4: ( ^( 'case' block ) )+
            {
            // src\\grammars\\TBPTree.g:221:4: ( ^( 'case' block ) )+
            int cnt25=0;
            loop25:
            do {
                int alt25=2;
                int LA25_0 = input.LA(1);

                if ( (LA25_0==55) ) {
                    alt25=1;
                }


                switch (alt25) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:221:5: ^( 'case' block )
            	    {
            	    match(input,55,FOLLOW_55_in_nd_body1343); 

            	    match(input, Token.DOWN, null); 
            	    pushFollow(FOLLOW_block_in_nd_body1345);
            	    block34=block();

            	    state._fsp--;

            	     branches.add(block34); 

            	    match(input, Token.UP, null); 

            	    }
            	    break;

            	default :
            	    if ( cnt25 >= 1 ) break loop25;
                        EarlyExitException eee =
                            new EarlyExitException(25, input);
                        throw eee;
                }
                cnt25++;
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return branches;
    }
    // $ANTLR end "nd_body"


    // $ANTLR start "val"
    // src\\grammars\\TBPTree.g:224:1: val returns [TBPValue<String> value] : ^( VALUE ( IDF | m= method_call ) ) ;
    public final TBPValue<String> val() throws RecognitionException {
        TBPValue<String> value = null;

        CommonTree IDF35=null;
        MethodCall m = null;


        try {
            // src\\grammars\\TBPTree.g:225:2: ( ^( VALUE ( IDF | m= method_call ) ) )
            // src\\grammars\\TBPTree.g:225:4: ^( VALUE ( IDF | m= method_call ) )
            {
            match(input,VALUE,FOLLOW_VALUE_in_val1368); 

            match(input, Token.DOWN, null); 
            // src\\grammars\\TBPTree.g:225:12: ( IDF | m= method_call )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==IDF) ) {
                alt26=1;
            }
            else if ( (LA26_0==METHOD_CALL) ) {
                alt26=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // src\\grammars\\TBPTree.g:225:13: IDF
                    {
                    IDF35=(CommonTree)match(input,IDF,FOLLOW_IDF_in_val1371); 
                     value =new TBPValue<String>((IDF35!=null?IDF35.getText():null)); 

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:225:63: m= method_call
                    {
                    pushFollow(FOLLOW_method_call_in_val1379);
                    m=method_call();

                    state._fsp--;


                                    value =new TBPValue<String>(m); 

                    }
                    break;

            }


            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "val"


    // $ANTLR start "cond"
    // src\\grammars\\TBPTree.g:229:1: cond returns [ITBPCondition<String> value] : c1= condor ( '&&' c2= condor )* ;
    public final ITBPCondition<String> cond() throws RecognitionException {
        ITBPCondition<String> value = null;

        ITBPCondition<String> c1 = null;

        ITBPCondition<String> c2 = null;


        try {
            // src\\grammars\\TBPTree.g:230:2: (c1= condor ( '&&' c2= condor )* )
            // src\\grammars\\TBPTree.g:230:3: c1= condor ( '&&' c2= condor )*
            {
            pushFollow(FOLLOW_condor_in_cond1400);
            c1=condor();

            state._fsp--;

            value =c1;
            // src\\grammars\\TBPTree.g:230:26: ( '&&' c2= condor )*
            loop27:
            do {
                int alt27=2;
                int LA27_0 = input.LA(1);

                if ( (LA27_0==62) ) {
                    alt27=1;
                }


                switch (alt27) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:230:27: '&&' c2= condor
            	    {
            	    match(input,62,FOLLOW_62_in_cond1405); 
            	    pushFollow(FOLLOW_condor_in_cond1409);
            	    c2=condor();

            	    state._fsp--;

            	    value = new TBPAnd<String>(value,c2);

            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "cond"


    // $ANTLR start "condor"
    // src\\grammars\\TBPTree.g:234:1: condor returns [ITBPCondition<String> value] : c1= condelem ( '||' c2= condelem )* ;
    public final ITBPCondition<String> condor() throws RecognitionException {
        ITBPCondition<String> value = null;

        ITBPCondition<String> c1 = null;

        ITBPCondition<String> c2 = null;


        try {
            // src\\grammars\\TBPTree.g:235:2: (c1= condelem ( '||' c2= condelem )* )
            // src\\grammars\\TBPTree.g:235:4: c1= condelem ( '||' c2= condelem )*
            {
            pushFollow(FOLLOW_condelem_in_condor1432);
            c1=condelem();

            state._fsp--;

            value =c1;
            // src\\grammars\\TBPTree.g:235:29: ( '||' c2= condelem )*
            loop28:
            do {
                int alt28=2;
                int LA28_0 = input.LA(1);

                if ( (LA28_0==48) ) {
                    alt28=1;
                }


                switch (alt28) {
            	case 1 :
            	    // src\\grammars\\TBPTree.g:235:30: '||' c2= condelem
            	    {
            	    match(input,48,FOLLOW_48_in_condor1437); 
            	    pushFollow(FOLLOW_condelem_in_condor1441);
            	    c2=condelem();

            	    state._fsp--;

            	    value = new TBPOr<String>(value,c2); 

            	    }
            	    break;

            	default :
            	    break loop28;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "condor"


    // $ANTLR start "condelem"
    // src\\grammars\\TBPTree.g:239:1: condelem returns [ITBPCondition<String> value] : (f= IDF '==' s= IDF | f= IDF '!=' s= IDF | '!' c1= condelem | '?' | '(' c= cond ')' );
    public final ITBPCondition<String> condelem() throws RecognitionException {
        ITBPCondition<String> value = null;

        CommonTree f=null;
        CommonTree s=null;
        ITBPCondition<String> c1 = null;

        ITBPCondition<String> c = null;


        try {
            // src\\grammars\\TBPTree.g:240:2: (f= IDF '==' s= IDF | f= IDF '!=' s= IDF | '!' c1= condelem | '?' | '(' c= cond ')' )
            int alt29=5;
            switch ( input.LA(1) ) {
            case IDF:
                {
                int LA29_1 = input.LA(2);

                if ( (LA29_1==63) ) {
                    alt29=1;
                }
                else if ( (LA29_1==64) ) {
                    alt29=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 29, 1, input);

                    throw nvae;
                }
                }
                break;
            case 65:
                {
                alt29=3;
                }
                break;
            case 54:
                {
                alt29=4;
                }
                break;
            case 42:
                {
                alt29=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }

            switch (alt29) {
                case 1 :
                    // src\\grammars\\TBPTree.g:240:4: f= IDF '==' s= IDF
                    {
                    f=(CommonTree)match(input,IDF,FOLLOW_IDF_in_condelem1463); 
                    match(input,63,FOLLOW_63_in_condelem1465); 
                    s=(CommonTree)match(input,IDF,FOLLOW_IDF_in_condelem1469); 
                     value = new TBPEquals<String>((f!=null?f.getText():null),(s!=null?s.getText():null)); 

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:241:4: f= IDF '!=' s= IDF
                    {
                    f=(CommonTree)match(input,IDF,FOLLOW_IDF_in_condelem1478); 
                    match(input,64,FOLLOW_64_in_condelem1480); 
                    s=(CommonTree)match(input,IDF,FOLLOW_IDF_in_condelem1484); 
                     value = new TBPNotEquals<String>((f!=null?f.getText():null),(s!=null?s.getText():null)); 

                    }
                    break;
                case 3 :
                    // src\\grammars\\TBPTree.g:242:3: '!' c1= condelem
                    {
                    match(input,65,FOLLOW_65_in_condelem1490); 
                    pushFollow(FOLLOW_condelem_in_condelem1494);
                    c1=condelem();

                    state._fsp--;

                     value = new TBPNot<String>(c1); 

                    }
                    break;
                case 4 :
                    // src\\grammars\\TBPTree.g:243:4: '?'
                    {
                    match(input,54,FOLLOW_54_in_condelem1514); 
                     value = new TBPNondetCondition<String>(); 

                    }
                    break;
                case 5 :
                    // src\\grammars\\TBPTree.g:244:11: '(' c= cond ')'
                    {
                    match(input,42,FOLLOW_42_in_condelem1534); 
                    pushFollow(FOLLOW_cond_in_condelem1538);
                    c=cond();

                    state._fsp--;

                    match(input,43,FOLLOW_43_in_condelem1540); 
                     value = c; 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "condelem"


    // $ANTLR start "method_call"
    // src\\grammars\\TBPTree.g:249:1: method_call returns [MethodCall value] : ^( METHOD_CALL itf_= IDF meth_= IDF parlist ) ;
    public final MethodCall method_call() throws RecognitionException {
        MethodCall value = null;

        CommonTree itf_=null;
        CommonTree meth_=null;
        List<String> parlist36 = null;


        try {
            // src\\grammars\\TBPTree.g:249:39: ( ^( METHOD_CALL itf_= IDF meth_= IDF parlist ) )
            // src\\grammars\\TBPTree.g:250:2: ^( METHOD_CALL itf_= IDF meth_= IDF parlist )
            {
            match(input,METHOD_CALL,FOLLOW_METHOD_CALL_in_method_call1563); 

            match(input, Token.DOWN, null); 
            itf_=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_call1567); 
            meth_=(CommonTree)match(input,IDF,FOLLOW_IDF_in_method_call1571); 
            pushFollow(FOLLOW_parlist_in_method_call1573);
            parlist36=parlist();

            state._fsp--;


            match(input, Token.UP, null); 
              value = new MethodCall((itf_!=null?itf_.getText():null), (meth_!=null?meth_.getText():null), parlist36);  

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "method_call"


    // $ANTLR start "parlist"
    // src\\grammars\\TBPTree.g:254:1: parlist returns [List<String> value] : ^( PARLIST ( param )* ) ;
    public final List<String> parlist() throws RecognitionException {
        List<String> value = null;

        String param37 = null;


         ArrayList<String> params = new  ArrayList<String>(); 
        try {
            // src\\grammars\\TBPTree.g:256:2: ( ^( PARLIST ( param )* ) )
            // src\\grammars\\TBPTree.g:256:4: ^( PARLIST ( param )* )
            {
            match(input,PARLIST,FOLLOW_PARLIST_in_parlist1599); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // src\\grammars\\TBPTree.g:256:14: ( param )*
                loop30:
                do {
                    int alt30=2;
                    int LA30_0 = input.LA(1);

                    if ( (LA30_0==IDF||LA30_0==54) ) {
                        alt30=1;
                    }


                    switch (alt30) {
                	case 1 :
                	    // src\\grammars\\TBPTree.g:256:15: param
                	    {
                	    pushFollow(FOLLOW_param_in_parlist1602);
                	    param37=param();

                	    state._fsp--;

                	    params.add(param37);

                	    }
                	    break;

                	default :
                	    break loop30;
                    }
                } while (true);


                match(input, Token.UP, null); 
            }
             value = params; 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "parlist"


    // $ANTLR start "param"
    // src\\grammars\\TBPTree.g:260:1: param returns [String value] : (v= IDF | '?' );
    public final String param() throws RecognitionException {
        String value = null;

        CommonTree v=null;

        try {
            // src\\grammars\\TBPTree.g:261:9: (v= IDF | '?' )
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==IDF) ) {
                alt31=1;
            }
            else if ( (LA31_0==54) ) {
                alt31=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 31, 0, input);

                throw nvae;
            }
            switch (alt31) {
                case 1 :
                    // src\\grammars\\TBPTree.g:261:11: v= IDF
                    {
                    v=(CommonTree)match(input,IDF,FOLLOW_IDF_in_param1634); 
                    value = (v!=null?v.getText():null);

                    }
                    break;
                case 2 :
                    // src\\grammars\\TBPTree.g:262:11: '?'
                    {
                    match(input,54,FOLLOW_54_in_param1648); 
                    value ="?";

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "param"

    // Delegated rules


    protected DFA17 dfa17 = new DFA17(this);
    static final String DFA17_eotS =
        "\17\uffff";
    static final String DFA17_eofS =
        "\17\uffff";
    static final String DFA17_minS =
        "\1\12\2\uffff\2\2\4\uffff\2\12\4\uffff";
    static final String DFA17_maxS =
        "\1\61\2\uffff\2\2\4\uffff\2\61\4\uffff";
    static final String DFA17_acceptS =
        "\1\uffff\1\1\1\2\2\uffff\1\5\1\6\1\11\1\12\2\uffff\1\7\1\3\1\10"+
        "\1\4";
    static final String DFA17_specialS =
        "\17\uffff}>";
    static final String[] DFA17_transitionS = {
            "\1\10\1\uffff\1\7\22\uffff\1\2\14\uffff\1\5\1\uffff\1\1\1\3"+
            "\1\4\1\6",
            "",
            "",
            "\1\11",
            "\1\12",
            "",
            "",
            "",
            "",
            "\1\14\1\uffff\1\14\13\uffff\1\13\6\uffff\1\14\14\uffff\1\14"+
            "\1\uffff\4\14",
            "\1\16\1\uffff\1\16\13\uffff\1\15\6\uffff\1\16\14\uffff\1\16"+
            "\1\uffff\4\16",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA17_eot = DFA.unpackEncodedString(DFA17_eotS);
    static final short[] DFA17_eof = DFA.unpackEncodedString(DFA17_eofS);
    static final char[] DFA17_min = DFA.unpackEncodedStringToUnsignedChars(DFA17_minS);
    static final char[] DFA17_max = DFA.unpackEncodedStringToUnsignedChars(DFA17_maxS);
    static final short[] DFA17_accept = DFA.unpackEncodedString(DFA17_acceptS);
    static final short[] DFA17_special = DFA.unpackEncodedString(DFA17_specialS);
    static final short[][] DFA17_transition;

    static {
        int numStates = DFA17_transitionS.length;
        DFA17_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA17_transition[i] = DFA.unpackEncodedString(DFA17_transitionS[i]);
        }
    }

    class DFA17 extends DFA {

        public DFA17(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 17;
            this.eot = DFA17_eot;
            this.eof = DFA17_eof;
            this.min = DFA17_min;
            this.max = DFA17_max;
            this.accept = DFA17_accept;
            this.special = DFA17_special;
            this.transition = DFA17_transition;
        }
        public String getDescription() {
            return "147:1: p_exp returns [TBPProvisionNode<String> value] : ( ^( '+' a= p_exp b= p_exp ) | ^( ';' a= p_exp b= p_exp ) | ^( '|' a= p_exp b= p_exp ) | ^( '||' a= p_exp b= p_exp ) | ^( '*' a= p_exp ) | ^( '|*' a= p_exp ) | ^( '|' d= DIGITS b= p_exp ) | ^( '||' d= DIGITS b= p_exp ) | ^( EVENT (m= method_call )? ( IDF )? ) | ^( ANN_PROVISION annotation inner= p_exp ) );";
        }
    }
 

    public static final BitSet FOLLOW_28_in_component50 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_component52 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_component76 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_type_in_component84 = new BitSet(new long[]{0x0000000000000018L});
    public static final BitSet FOLLOW_33_in_component122 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_var_in_component131 = new BitSet(new long[]{0x0000000000000028L});
    public static final BitSet FOLLOW_34_in_component167 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_provision_in_component170 = new BitSet(new long[]{0x0000000000000048L});
    public static final BitSet FOLLOW_35_in_component205 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_reaction_in_component209 = new BitSet(new long[]{0x0000000000000088L});
    public static final BitSet FOLLOW_36_in_component245 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_thread_in_component251 = new BitSet(new long[]{0x0000000000000108L});
    public static final BitSet FOLLOW_TYPEDEF_in_type335 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_type339 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_type344 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_VARDEF_in_var386 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_var390 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_var394 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_var398 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VARDEF_in_var409 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_var411 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VARDEF_in_var_decl432 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_var_decl436 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_var_decl440 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_var_decl444 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PROVISION_in_provision467 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_provision469 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_method_list_in_provision471 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_IDF_in_provision473 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_METHOD_LIST_in_method_list503 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_method_list_element_in_method_list506 = new BitSet(new long[]{0x0000000000008008L});
    public static final BitSet FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element530 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_44_in_method_list_element532 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element541 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_method_list_element543 = new BitSet(new long[]{0x0000100000000000L});
    public static final BitSet FOLLOW_44_in_method_list_element545 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_METHOD_LIST_ELEMENT_in_method_list_element554 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_method_list_element558 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_method_list_element562 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REACTION_in_reaction581 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_method_decl_in_reaction583 = new BitSet(new long[]{0x0000000000000208L});
    public static final BitSet FOLLOW_annotation_in_reaction588 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_THREAD_in_thread617 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_33_in_thread622 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_var_decl_in_thread625 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_thread634 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_IDF_in_thread639 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ANNOTATION_in_annotation669 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_annotation673 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_IDF_in_annotation689 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_annotation693 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_46_in_p_exp732 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp737 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp741 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_31_in_p_exp750 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp755 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp759 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_47_in_p_exp770 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp775 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp779 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_48_in_p_exp789 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp793 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp797 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_44_in_p_exp807 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp812 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_49_in_p_exp830 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_p_exp_in_p_exp834 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_47_in_p_exp852 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DIGITS_in_p_exp857 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp861 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_48_in_p_exp869 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DIGITS_in_p_exp874 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp878 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_EVENT_in_p_exp886 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_method_call_in_p_exp891 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_IDF_in_p_exp895 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ANN_PROVISION_in_p_exp907 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_annotation_in_p_exp909 = new BitSet(new long[]{0x0003D00080001400L});
    public static final BitSet FOLLOW_p_exp_in_p_exp913 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_METHOD_DECL_in_method_decl943 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_method_decl947 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_method_decl951 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_PARLIST_DECL_in_method_decl958 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_method_decl963 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_method_decl967 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_IDF_in_method_decl981 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_33_in_method_decl988 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_var_decl_in_method_decl991 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_method_decl1001 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_31_in_block1023 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_block_in_block1027 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_block1031 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_52_in_block1040 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_val_in_block1042 = new BitSet(new long[]{0x00A0000000000000L});
    public static final BitSet FOLLOW_body_in_block1044 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_SWITCH_ND_in_block1057 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_nd_body_in_block1059 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_56_in_block1072 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_block1074 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_block1078 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_57_in_block1088 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_block1090 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_block1094 = new BitSet(new long[]{0x1B18000080E12828L});
    public static final BitSet FOLLOW_block_in_block1098 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_59_in_block1108 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_block1110 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_block1114 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_60_in_block1126 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_block1128 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ASSIGNMENT_in_block1141 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_block1143 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_val_in_block1145 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_RETURN_in_block1157 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_block1159 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_BLOCK_in_block1180 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_block_in_block1184 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_51_in_block1202 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_empty_in_block1204 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_method_call_in_block1220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANN_STATEMENT_in_block1241 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_annotation_in_block1243 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_block1247 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_55_in_body1284 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_body1286 = new BitSet(new long[]{0x1B18000080E12820L});
    public static final BitSet FOLLOW_block_in_body1290 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_53_in_body1304 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_block_in_body1308 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_55_in_nd_body1343 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_block_in_nd_body1345 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VALUE_in_val1368 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_val1371 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_method_call_in_val1379 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_condor_in_cond1400 = new BitSet(new long[]{0x4000000000000002L});
    public static final BitSet FOLLOW_62_in_cond1405 = new BitSet(new long[]{0x0040040002000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_condor_in_cond1409 = new BitSet(new long[]{0x4000000000000002L});
    public static final BitSet FOLLOW_condelem_in_condor1432 = new BitSet(new long[]{0x0001000000000002L});
    public static final BitSet FOLLOW_48_in_condor1437 = new BitSet(new long[]{0x0040040002000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_condelem_in_condor1441 = new BitSet(new long[]{0x0001000000000002L});
    public static final BitSet FOLLOW_IDF_in_condelem1463 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_63_in_condelem1465 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_condelem1469 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDF_in_condelem1478 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_64_in_condelem1480 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_condelem1484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_65_in_condelem1490 = new BitSet(new long[]{0x0040040002000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_condelem_in_condelem1494 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_54_in_condelem1514 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_42_in_condelem1534 = new BitSet(new long[]{0x0040040002000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_cond_in_condelem1538 = new BitSet(new long[]{0x0000080000000000L});
    public static final BitSet FOLLOW_43_in_condelem1540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_METHOD_CALL_in_method_call1563 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IDF_in_method_call1567 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_IDF_in_method_call1571 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_parlist_in_method_call1573 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PARLIST_in_parlist1599 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_param_in_parlist1602 = new BitSet(new long[]{0x0040000002000008L});
    public static final BitSet FOLLOW_IDF_in_param1634 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_54_in_param1648 = new BitSet(new long[]{0x0000000000000002L});

}