package org.ow2.dsrg.fm.tbplib.util;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 9.7.2010
 * Time: 17:23:09
 * To change this template use File | Settings | File Templates.
 */
public class ErrorCollector {
    private List<String> errorList = new ArrayList<String>();
    public void addError(String error) {
        errorList.add(error);
    }

    public boolean noErrors(){
        return errorList.isEmpty();
    }

    public void reportErrors(PrintStream s){
        for (String err:errorList){
            s.println(err);
        }
    }

    public String reportErrors(){
        StringBuilder sb = new StringBuilder();
        for (String err:errorList){
            sb.append(err);
            sb.append('\n');
        }
        return sb.toString();
    }
}
